library fact_schemas;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/fact_schemas/fact_schemas.dart';

import 'model/fact_agent.dart';
import 'model/fact_duration.dart';
import 'model/fact_link.dart';
import 'model/fact_meta_date.dart';
import 'model/fact_recurrence.dart';
import 'model/fact_schema.dart';
import 'model/fact_schema_list.dart';
import 'model/fact_schema_template.dart';
import 'model/fact_schemas.dart';
import 'model/fact_tense.dart';
import 'model/remindable_info.dart';
import 'model/time_sensitivity.dart';

export 'package:sunny_service_stubs/models/fact_schemas/fact_schemas.dart';

export 'api/fact_schema_api.dart';
export 'ext/ext.dart';
export 'model/fact_agent.dart';
export 'model/fact_duration.dart';
export 'model/fact_link.dart';
export 'model/fact_meta_date.dart';
export 'model/fact_recurrence.dart';
export 'model/fact_schema.dart';
export 'model/fact_schema_list.dart';
export 'model/fact_schema_template.dart';
export 'model/fact_schemas.dart';
export 'model/fact_tense.dart';
export 'model/remindable_info.dart';
export 'model/time_sensitivity.dart';

const factSchemaModuleRef = MModuleRef.ofParts("sunny", "factSchema", "0.0.1");

registerFact_schemasModels(
    MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  FactAgent.init();
  FactDuration.init();
  enumRegistry.register("sunny.factSchema.definitions.factAgent",
      values: IFactAgent.values,
      factory: (value) => FactAgent.fromJson(value)!);
  enumRegistry.register("sunny.factSchema.definitions.factDuration",
      values: IFactDuration.values,
      factory: (value) => FactDuration.fromJson(value)!);
  modelRegistry.register(
      FactLinkRef, (json) => FactLink(json as Map<String, dynamic>));
  IFactLink.of = FactLink.of;
  IFactLink.fromJson = FactLink.fromJson;

  modelRegistry.register(
      FactMetaDateRef, (json) => FactMetaDate(json as Map<String, dynamic>));
  IFactMetaDate.of = FactMetaDate.of;
  IFactMetaDate.fromJson = FactMetaDate.fromJson;

  FactRecurrence.init();
  enumRegistry.register("sunny.factSchema.definitions.factRecurrence",
      values: IFactRecurrence.values,
      factory: (value) => FactRecurrence.fromJson(value)!);
  modelRegistry.register(
      FactSchemaRef, (json) => FactSchema(json as Map<String, dynamic>));
  IFactSchema.of = FactSchema.of;
  IFactSchema.fromJson = FactSchema.fromJson;

  modelRegistry.register(FactSchemaListRef,
      (json) => FactSchemaList(json as Map<String, dynamic>));
  IFactSchemaList.of = FactSchemaList.of;
  IFactSchemaList.fromJson = FactSchemaList.fromJson;

  modelRegistry.register(FactSchemaTemplateRef,
      (json) => FactSchemaTemplate(json as Map<String, dynamic>));
  IFactSchemaTemplate.of = FactSchemaTemplate.of;
  IFactSchemaTemplate.fromJson = FactSchemaTemplate.fromJson;

  modelRegistry.register(
      FactSchemasRef, (json) => FactSchemas(json as Map<String, dynamic>));
  IFactSchemas.of = FactSchemas.of;
  IFactSchemas.fromJson = FactSchemas.fromJson;

  FactTense.init();
  enumRegistry.register("sunny.factSchema.definitions.factTense",
      values: IFactTense.values,
      factory: (value) => FactTense.fromJson(value)!);
  modelRegistry.register(RemindableInfoRef,
      (json) => RemindableInfo(json as Map<String, dynamic>));
  IRemindableInfo.of = RemindableInfo.of;
  IRemindableInfo.fromJson = RemindableInfo.fromJson;

  TimeSensitivity.init();
  enumRegistry.register("sunny.factSchema.definitions.timeSensitivity",
      values: ITimeSensitivity.values,
      factory: (value) => TimeSensitivity.fromJson(value)!);
}
